%global __strip %{mingw_strip}
%global __objdump %{mingw_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{mingw_findrequires}
%global __find_provides %{mingw_findprovides}
%define __debug_install_post %{mingw_debug_install_post}

%global mingw_pkg_name llvm
%global mingw_build_win32 1
%global mingw_build_win64 1

Name:           mingw-llvm
Version:        3.0svn
Release:        0.1svn.132401%{?dist}
Summary:        Cross compiled Low Level Virtual Machine

Group:          Development/Languages
License:        NCSA
URL:            http://llvm.org/
Source0:        http://llvm.org/releases/%{version}/llvm-%{version}.tar.gz
Source1:        http://llvm.org/releases/%{version}/clang-%{version}.tar.gz
# The tarballs have been made from SVN export #132401
# Data files should be installed with timestamps preserved
Patch0:         llvm-2.6-timestamp.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch

BuildRequires:  mingw-filesystem >= 65
BuildRequires:  mingw32-gcc
BuildRequires:  mingw64-gcc
BuildRequires:  mingw32-gcc-c++
BuildRequires:  mingw64-gcc-c++
BuildRequires:  bison
BuildRequires:  chrpath
BuildRequires:  flex
BuildRequires:  groff
BuildRequires:  libtool-ltdl-devel
# for DejaGNU test suite
BuildRequires:  dejagnu tcl-devel python

%{?mingw_default_requires}
%{?mingw_debug_package}

%description
LLVM is a compiler infrastructure designed for compile-time,
link-time, runtime, and idle-time optimization of programs from
arbitrary programming languages.  The compiler infrastructure includes
mirror sets of programming tools as well as libraries with equivalent
functionality.


#Mingw32
%package -n mingw32-%{mingw_pkg_name}
Summary:        Libraries and header files for LLVM
Group:          Development/Languages

%description -n mingw32-%{mingw_pkg_name}
LLVM is a compiler infrastructure designed for compile-time,
link-time, runtime, and idle-time optimization of programs from
arbitrary programming languages.  The compiler infrastructure includes
mirror sets of programming tools as well as libraries with equivalent
functionality.

%package -n mingw32-clang
Summary:        A C language family front-end for LLVM
License:        NCSA
Group:          Development/Languages
Requires:       mingw32-%{mingw_pkg_name} = %{version}-%{release}
# clang requires gcc; clang++ gcc-c++
Requires:       gcc-c++

%description -n mingw32-clang
clang: noun
    1. A loud, resonant, metallic sound.
    2. The strident call of a crane or goose.
    3. C-language family front-end toolkit.

The goal of the Clang project is to create a new C, C++, Objective C
and Objective C++ front-end for the LLVM compiler. Its tools are built
as libraries and designed to be loosely-coupled and extensible.


%prep
%setup -q -n llvm-%{version} -a1 %{?_with_gcc:-a2}
mv clang-%{version} tools/clang

%patch0 -p1 -b .timestamp

# Encoding fix
#(cd tools/clang/docs && \
#    iconv -f ISO88591 -t UTF8 BlockImplementation.txt \
#    -o BlockImplementation.txt)

%build
%{mingw_set_suffix}
mkdir -p build_win32$suffix build_win64$suffix
pushd build_win32$suffix
%{mingw32_env} ; ../configure \
        --host=%{mingw32_host} \
        --build=%_build \
        --prefix=%{mingw32_prefix} \
        --target=%{mingw32_target} \
        --exec-prefix=%{mingw32_exec_prefix} \
        --bindir=%{mingw32_bindir} \
        --sbindir=%{mingw32_sbindir} \
        --sysconfdir=%{mingw32_sysconfdir} \
        --datadir=%{mingw32_datadir}/%{mingw_pkg_name} \
        --includedir=%{mingw32_includedir} \
        --libdir=%{mingw32_libdir}/%{mingw_pkg_name} \
        --libexecdir=%{mingw32_libexecdir} \
        --localstatedir=%{mingw32_localstatedir} \
        --sharedstatedir=%{mingw32_sharedstatedir} \
        --mandir=%{mingw32_mandir} \
        --infodir=%{mingw32_infodir} \
        --disable-assertions \
        --enable-debug-runtime \
        --enable-jit \
        --enable-shared \
        --with-c-include-dirs=%{mingw32_includedir}:$(find %{mingw32_prefix}/lib/gcc/*/* \
           -maxdepth 0 -type d)/include \
        --with-cxx-include-root=$(find %{mingw32_includedir}/c++/* -maxdepth 0 -type d) \
        --with-cxx-include-arch=%{_arch}-%{_vendor}-%{_os} \
        --with-cxx-include-32bit-dir=32
# and:
# some say this is required too:
#       LDFLAGS=-Wl,--stack,16777216

# FIXME file this
# configure does not properly specify libdir
#sed -i 's|(PROJ_prefix)/lib|%{mingw32_libdir}/%{mingw_pkg_name}|g' Makefile.config

# we need to unset mingw variable after configure, to allow BuildTools
# to be native
_PREFIX="%{_bindir}/%{mingw32_target}-"
for i in `ls -1 ${_PREFIX}* | grep -v 'gcc-' | grep -v 'ld.bfd'`; do
    x=`echo $i|sed "s,${_PREFIX},,"|tr "a-z+-" "A-ZX_"|tr -d '.'`; \
    unset $x
done
unset CC
make %{_smp_mflags}
popd

#configure mingw64
mkdir -p build_win64$suffix build_win64$suffix
pushd build_win64$suffix
%{mingw64_env} ; ../configure \
        --host=%{mingw64_host} \
        --build=%_build \
        --prefix=%{mingw64_prefix} \
        --target=%{mingw64_target} \
        --exec-prefix=%{mingw64_exec_prefix} \
        --bindir=%{mingw64_bindir} \
        --sbindir=%{mingw64_sbindir} \
        --sysconfdir=%{mingw64_sysconfdir} \
        --datadir=%{mingw64_datadir}/%{mingw_pkg_name} \
        --includedir=%{mingw64_includedir} \
        --libdir=%{mingw64_libdir}/%{mingw_pkg_name} \
        --libexecdir=%{mingw64_libexecdir} \
        --localstatedir=%{mingw64_localstatedir} \
        --sharedstatedir=%{mingw64_sharedstatedir} \
        --mandir=%{mingw64_mandir} \
        --infodir=%{mingw64_infodir} \
        --disable-assertions \
        --enable-debug-runtime \
        --enable-jit \
        --enable-shared \
        --with-c-include-dirs=%{mingw64_includedir}:$(find %{mingw64_prefix}/lib/gcc/*/* \
           -maxdepth 0 -type d)/include \
        --with-cxx-include-root=$(find %{mingw64_includedir}/c++/* -maxdepth 0 -type d) \
        --with-cxx-include-arch=%{_arch}-%{_vendor}-%{_os} \
        --with-cxx-include-32bit-dir=32
# and:
# some say this is required too:
#       LDFLAGS=-Wl,--stack,16777216

# FIXME file this
# configure does not properly specify libdir
#sed -i 's|(PROJ_prefix)/lib|%{mingw64_libdir}/%{mingw_pkg_name}|g' Makefile.config

# we need to unset mingw variable after configure, to allow BuildTools
# to be native
_PREFIX="%{_bindir}/%{mingw64_target}-"
for i in `ls -1 ${_PREFIX}* | grep -v 'gcc-' | grep -v 'ld.bfd'`; do
    x=`echo $i|sed "s,${_PREFIX},,"|tr "a-z+-" "A-ZX_"|tr -d '.'`; \
    unset $x
done
unset CC
#FIXME: make fails:
# - export symbols need leading _ for some reason
# - still, some tools fail to link with missing symbols..
#make VERBOSE=1 
popd

%install
rm -rf $RPM_BUILD_ROOT
pushd build_win32$suffix
make install DESTDIR=$RPM_BUILD_ROOT PROJ_docsdir=/moredocs
popd

rm -rf %{buildroot}/moredocs
rm -rf %{buildroot}/%{mingw32_mandir}

# FIXME?
#find %%{buildroot} -name .dir -print0 | xargs -0r rm -f
#file %{buildroot}/%{_bindir}/* | awk -F: '$2~/ELF/{print $1}' | xargs -r chrpath -d
#file %{buildroot}/%{_libdir}/llvm/*.so | awk -F: '$2~/ELF/{print $1}' | xargs -r chrpath -d
#chrpath -d %%{buildroot}/%%{_libexecdir}/clang-cc

# FIXME file this bug
#sed -i 's,ABS_RUN_DIR/lib",ABS_RUN_DIR/%{_lib}/%{name}",' \
#  %{buildroot}%{_bindir}/llvm-config

chmod -x %{buildroot}%{mingw32_libdir}/*.a
#chmod -x %{buildroot}%{mingw64_libdir}/*.a


%files -n mingw32-%{mingw_pkg_name}
%defattr(-,root,root,-)
%doc CREDITS.TXT LICENSE.TXT README.txt
%{mingw32_bindir}/bugpoint.exe
%{mingw32_bindir}/llc.exe
%{mingw32_bindir}/lli.exe
%{mingw32_bindir}/llvm*.exe
%{mingw32_bindir}/opt.exe
%{mingw32_bindir}/BugpointPasses.dll
%{mingw32_bindir}/EnhancedDisassembly.dll
%{mingw32_bindir}/LLVM-3.0svn.dll
%{mingw32_bindir}/LTO.dll
%{mingw32_bindir}/macho-dump.exe
# devel
%{mingw32_bindir}/llvm-config
%{mingw32_includedir}/%{mingw_pkg_name}
%{mingw32_includedir}/%{mingw_pkg_name}-c
%{mingw32_libdir}/*.a

%files -n mingw32-clang
%defattr(-,root,root,-)
%{mingw32_bindir}/clang*.exe
%{mingw32_bindir}/tblgen.exe
%{mingw32_bindir}/clang.dll
%{mingw32_libdir}/clang
# clang-devel
%{mingw32_includedir}/clang
%{mingw32_includedir}/clang-c
# clang-analyzer


%changelog
* Wed Jun 1 2011 Marc-André Lureau <marcandre.lureau@redhat.com> 3.0-0.1svn.132401
- Initial MinGW packaging.
